% Function to plot velocities from CFD simulations.  Called in PFBuoyant16_thesis.

function [plot] = ArrowPlot(iteration, istore, jstore, kstore, nx, ny, nz, u, v, w)

coords=0;
uplot=0;
vplot=0;
uLR=0;
vLR=0;
i1=0;
j1=0;
n=1; % resolution

% Re-align velocity nodes to cell centres
for i=1:nx
    for j=1:ny
        for k=1:nz
            utemp(i,j,k)=(u(i,j,k)+u(i+1,j,k))/2;
            vtemp(i,j,k)=(v(i,j,k)+v(i,j+1,k))/2;
            wtemp(i,j,k)=(w(i,j,k)+w(i,j,k+1))/2;
        end
    end
end
[u v w]=deal(0);
u=utemp;
v=vtemp;
w=wtemp;
  
prompt='Select plane - 1 for x, 2 for y, 3 for z';
plane=input(prompt);

while plane~=0
    [x y z uslice vslice wslice]=deal(0);
    if plane==1
        prompt='Select x co-ordinate';
        i=input(prompt);
        if i>istore-2
            'This exceeds max x co-ordinate, x set to:'
            i=istore-2;
%             i
        end
        [x,y]=meshgrid(1:size(u,3),1:size(u,2));
        z=i*(x.^0);
        for a=1:size(u,2)
            for b=1:size(u,3)
                uslice(a,b)=w(i,a,b); % w wants to be aligned with the x-axis of the plot
                vslice(a,b)=v(i,a,b); % v wants to be aligned with the y-axis etc.
                wslice(a,b)=u(i,a,b);
            end
        end
        quiver3(x,y,z,uslice,vslice,wslice)
        xlabel('y');
        ylabel('z');
    elseif plane==2
        prompt='Select y co-ordinate';
        i=input(prompt);
        if i>jstore-2
            'This exceeds max y co-ordinate, y set to:'
            i=jstore-2;
            i
        end
        [x,y]=meshgrid(1:size(u,1),1:size(u,3));
        z=i*(x.^0);
        for a=1:size(u,3)
            for b=1:size(u,1)
                uslice(a,b)=u(b,i,a);
                vslice(a,b)=w(b,i,a);
                wslice(a,b)=v(b,i,a);
            end
        end
        quiver3(x,y,z,uslice,vslice,wslice)
        xlabel('x');
        ylabel('z');
    elseif plane==3
        prompt='Select z co-ordinate';
        i=input(prompt);
        if i>kstore-2
            'This exceeds max z co-ordinate, z set to:'
            i=kstore-2;
            i
        end
        [x,y]=meshgrid(1:size(u,1),1:size(u,2));
        z=i*(x.^0);
        for a=1:size(u,2)
            for b=1:size(u,1)
                uslice(a,b)=u(b,a,i);
                vslice(a,b)=v(b,a,i);
                wslice(a,b)=w(b,a,i);
            end
        end
        quiver3(x,y,z,uslice,vslice,wslice)
        xlabel('x');
        ylabel('y');
    end

    view(2);

    prompt='Select plane: 1 for x, 2 for y, 3 for z, 0 for no more arrow plots.';
    plane=input(prompt);  
    
end